/*
 * IndexPanel.java
 *
 * Created on January 20, 2007, 4:19 PM
 */

package info.heinzelnisse.he;

import java.awt.Point;
import java.awt.Rectangle;
import java.awt.event.KeyEvent;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import javax.swing.SwingUtilities;

/**
 *
 * @author  Heiko Klein
 */
public class IndexPanel extends javax.swing.JPanel implements PropertyChangeListener, SearchKeyEventListener {
    ControllerBean controller = null;
    HeinzelTable ht = null;
    
    /** Creates new form IndexPanel */
    public IndexPanel() {
        initComponents();
    }
    
    public void setController(ControllerBean controller) {
        this.controller = controller;
        controller.addPropertyChangeListener(this);
        controller.addSearchKeyEventListener(this);
        final ControllerBean cb = controller;
        setHeinzelTable(controller.getHeinzelTable());
    }
    
    private void setHeinzelTable(HeinzelTable ht) {
        this.ht = ht;
        ht.addPropertyChangeListener(this);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        jList1 = new javax.swing.JList();

        setBorder(javax.swing.BorderFactory.createTitledBorder("Index"));

        jScrollPane1.setHorizontalScrollBarPolicy(javax.swing.ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);

        jList1.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        jList1.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                jList1ValueChanged(evt);
            }
        });
        jScrollPane1.setViewportView(jList1);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 79, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane1, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 104, Short.MAX_VALUE)
        );
    }// </editor-fold>//GEN-END:initComponents
    
    private void jList1ValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_jList1ValueChanged
        controller.setIndexWord((String)jList1.getSelectedValue());
    }//GEN-LAST:event_jList1ValueChanged
    
    public void propertyChange(PropertyChangeEvent evt) {
        // TODO: make sure all swing actions start in event-thread
        
        if (evt.getPropertyName() == HeinzelTable.FINISHED_READING) {
            fillJList1();
        } else if (evt.getPropertyName() == ControllerBean.SEARCH_STRING) {
            changeJList1Selection();
        }
    }
    
    private void changeJList1Selection() {
        final int idx = controller.getSearchStringIdx();
        final javax.swing.JList jList1 = this.jList1;
        
        SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                jList1.setSelectedIndex(idx);
                Point p = jList1.indexToLocation(idx-1);
                if (p != null) {
                    jScrollPane1.getViewport().setViewPosition(p);
                    
                }
            }
        });
    }
    
    protected void fillJList1() {
        final String[] strings = controller.getSortedItems().toArray(new String[] {});
        final int idx = controller.getSearchStringIdx("Heinzelnisse");
        final javax.swing.JList jList1 = this.jList1;
        final javax.swing.JScrollPane jScrollPane1 = this.jScrollPane1;
        SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                jList1.setModel(new javax.swing.AbstractListModel() {
                    public int getSize() { return strings.length; }
                    public Object getElementAt(int i) { return strings[i]; }
                });
                goSelectIndex(idx);
            }
        });
        controller.setTranslationsByExactWord("Heinzelnisse");
    }
    
    private void goSelectIndex(int idx) {
        jList1.clearSelection();
        jList1.setSelectedIndex(idx);
        Point p = jList1.indexToLocation(idx-1);
        if (p != null) {
            jScrollPane1.getViewport().setViewPosition(p);
        }
        
    }
    
    public void searchKeyReleased(KeyEvent evt) {
        int idx = jList1.getSelectedIndex();
        switch (evt.getKeyCode()) {
            case KeyEvent.VK_UP:
            case KeyEvent.VK_KP_UP: goSelectIndex(idx-1); break;
            case KeyEvent.VK_DOWN:
            case KeyEvent.VK_KP_DOWN: goSelectIndex(idx+1); break;
            default:
        }
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JList jList1;
    private javax.swing.JScrollPane jScrollPane1;
    // End of variables declaration//GEN-END:variables
    
}
