/*
 * BitObfuscatorOutputStreamTest.java
 * JUnit based test
 *
 * Created on September 23, 2007, 9:12 PM
 */

package info.heinzelnisse.he;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.Writer;
import junit.framework.TestCase;

/**
 *
 * @author hklein
 */
public class BitObfuscatorOutputStreamTest extends TestCase {
    final File file = new File("test.txt");
    final String testString = "Hello World\tblabla\t";
    final String charset = "ISO8859-1";
    
    public BitObfuscatorOutputStreamTest(String testName) {
        super(testName);
    }

    @Override
    protected void setUp() throws Exception {
        super.setUp();
    }

    public void testWrite() throws Exception {
        Writer os = new OutputStreamWriter(new BitObfuscatorOutputStream(new FileOutputStream(file)), charset);
        assertNotNull(os);
        os.write(testString);
        os.close();
        
        BufferedReader isr = new BufferedReader(new InputStreamReader(new BitObfuscatorInputStream(new FileInputStream(file)), charset));
        String s = isr.readLine();
        assertEquals(testString,s);
        file.delete();
    }
    
}
