/*
 * HeinzelTableTest.java
 * JUnit based test
 *
 * Created on January 26, 2007, 8:14 PM
 */

package info.heinzelnisse.he;

import java.text.Collator;
import java.text.RuleBasedCollator;
import java.util.Locale;
import junit.framework.*;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.URL;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.StringTokenizer;
import java.util.TreeSet;

/**
 *
 * @author Heiko Klein
 */
public class HeinzelTableTest extends TestCase {
    
    public HeinzelTableTest(String testName) {
        super(testName);
    }

    public void testRun() {
        HeinzelTable ht = new HeinzelTable();
        Thread t = new Thread(ht);
        t.start();
        try {
            t.join(); // make sure thread finished
        } catch (InterruptedException ex) {
            ex.printStackTrace();
        } // make sure thread finished
        //System.err.println(((RuleBasedCollator) Collator.getInstance(new Locale("no"))).getRules());
        assertTrue(ht.searchItems("hallo").size() > 0);
    }

    public void testSearchFulltextTranslations() {
        HeinzelTable ht = new HeinzelTable();
        Thread t = new Thread(ht);
        t.start();
        try {
            t.join(); // make sure thread finished
        } catch (InterruptedException ex) {
            ex.printStackTrace();
        }
        assertTrue(ht.searchFulltextTranslations("Heinzelnisse").size() > 0);
        assertFalse(ht.searchFulltextTranslations("lsdjf").size() > 0);
        //lookup german
        assertTrue(ht.searchFulltextTranslations("Heinzelnisse", true, true, false, false, false, false, true, false, false, false, false).size() > 0);
        // lookup norwegian
        assertFalse(ht.searchFulltextTranslations("Heinzelnisse", true, true, true, false, false, false, false, false, false, false, false).size() > 0);
    }
}
