/*
 * HistoryTest.java
 * JUnit based test
 *
 * Created on September 5, 2007, 1:41 PM
 */

package info.heinzelnisse.he;

import junit.framework.*;
import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author Heiko Klein
 */
public class HistoryTest extends TestCase {
    History<String> history;
    
    public HistoryTest(String testName) {
        super(testName);
        
    }

    private void setupFast() {
        history = new History<String>(10, 1);
        history.addItem("1");
        try {
            Thread.sleep(10);
        } catch (InterruptedException ex) {
            ex.printStackTrace();
        }
        history.addItem("2");
        try {
            Thread.sleep(10);
        } catch (InterruptedException ex) {
            ex.printStackTrace();
        }
    }
    
    public void testaddItem() {
        history = new History<String>(10, 100);
        assertNull(history.getCurrent());
        history.addItem("1");
        try {
            Thread.sleep(150);
        } catch (InterruptedException ex) {
            ex.printStackTrace();
        }
        history.addItem("2");
        assertEquals("1",history.getCurrent());
        try {
            Thread.sleep(150);
        } catch (InterruptedException ex) {
            ex.printStackTrace();
        }
        assertEquals("2", history.getCurrent());
    }

    public void testGoBack() {
        setupFast();
        assertEquals("2", history.getCurrent());
        assertEquals("1", history.goBack());
    }

    public void testGoForward() {
        setupFast();
        history.goBack();
        assertEquals("2", history.goForward());
    }

    public void testGetCurrent() {
        // tested implicitly
    }

    public void testHasNext() {
        setupFast();
        assertFalse(history.hasNext());
        history.goBack();
        assertTrue(history.hasNext());
    }

    public void testHasPrevious() {
        setupFast();
        assertTrue(history.hasPrevious());
        history.goBack();
        assertFalse(history.hasPrevious());
    }
    
}
